#include <cstring>
#include <iostream>
#include <fstream>
using namespace std;

const int LEN[] = {
    1,
    2,
    3,
    3,
    4,
    4,
    5,
    4,
    5,
    5,
    6,
    5,
    6,
    6,
    6,
    5,
    6,
    6,
    7,
    6,
    7,
    7,
    7,
    6,
    7,
    7,
    7,
    7,
    8,
    7,
    8,
    6,
    7,
    7,
    8,
    7,
    8,
    8,
    8,
    7,
    8,
    8,
    8,
    8,
    8,
    8,
    9,
    7,
    8,
    8,
    8,
    8,
    9,
    8,
    9,
    8,
    9,
    9,
    9,
    8,
    9,
    9,
    9,
    7,
    8,
    8,
    9,
    8,
    9,
    9,
    10,
    8,
    9,
    9,
    9,
    9,
    9,
    9,
    10,
    8,
    9,
    9,
    9,
    9,
    9,
    9,
    10,
    9,
    10,
    9,
    10,
    9,
    10,
    10,
    10,
    8,
    9,
    9,
    9,
    9
};

const char *ERRORS[] = {
    "Invalid arguments.\n",
    "Failed to open the file.\n",
    "Number 'n' is invalid.\n",
    "Number 'm' is invalid.\n",
    "The length of chain is not equal to 'm'.\n"
};

void ThrowError(unsigned int x)
{
    cout << "ERROR: " << ERRORS[x];
}

int ToInt(const char *c)
{
    int len = strlen(c);
    int ans = 0;
    int p = 0;
    while ((c[p] >= '0' || c[p] <= '9') && p < len) {
        ans = (ans << 1) + (ans << 3) + (c[p] ^ 48);
        p++;
    }
    return ans;
}

int a[110];

bool check(int x)
{
    for (int i = 1; i < x; i++) {
        for (int j = i; j < x; j++) {
            if (a[i] + a[j] == a[x]) {
                return true;
            }
        }
    }
    return false;
}

int main(int argc, char **argv)
{
    bool ok = true;
    if (argc != 4) {
        ThrowError(0);
        return 0;
    }
    fstream fin(argv[1], ios_base::in);
    if (!fin.good()) {
        ThrowError(1);
        return 0;
    }
    int n = ToInt(argv[2]);
    if (n > 100 || n < 1) {
        ThrowError(2);
        return 0;
    }
    int m = ToInt(argv[3]);
    if (m != LEN[n - 1]) {
        ThrowError(3);
        return 0;
    }
    for (int i = 1; i <= n; i++) {
        fin >> a[i];
        if (!a[i]) {
            ThrowError(4);
            return 0;
        }
    }
    if (a[1] != 1) {
        cout << "A" << endl;
        ok = false;
    }
    if (a[m] != n) {
        cout << "B" << endl;
        ok = false;
    }
    for (int i = 1; i <= m; i++) {
        if (a[i] <= a[i - 1]) {
            cout << "C " << i << endl;
            ok = false;
        }
    }
    for (int i = 2; i <= m; i++) {
        if (!check(i)) {
            cout << "D " << i << endl;
            ok = false;
        }
    }
    if (ok) {
        cout << "ok" << endl;
    }
    return 0;
}
